from util import *

table_header = '''
\\setcounter{table}{1}
\\begin{table}
\\caption{
Numbers of different memory locations that are detected as racy.
}
\\label{tab:memloc}
\\setlength\\tabcolsep{1.5pt}
\\renewcommand{\\arraystretch}{1.2}
\\footnotesize
\\begin{tabular}{|c||c|c|c|}
\\hline
\\textbf{Benchmark} & \\textsf{SHB} & \\textsf{WCP} & $\\ZeroRevAlgo$ \\\\
\\hline
'''

table_footer = '''
\\hline
\\end{tabular}
\\end{table}
'''

selected_benches = [
  'ftpserver',
  'jigsaw',
  'xalan',
  'cryptorsa',
  'luindex',
  'sunflow',
  'linkedlist',
]

def print_table():
	
	totals = {}
	for algo in algos: totals[algo]={'racy_variables':0}

	results = parse_dir()
	body = ''
	for b in results:

		if not all and b not in selected_benches: continue

		body += '\\texttt{' + short_name(b) + '}' 
		for algo in algos:
			if algo == 'M2': continue
			body += ' & '
			if 'racy_variables' in results[b][algo]:
				totals[algo]['racy_variables'] += results[b][algo]['racy_variables']
				body += str(results[b][algo]['racy_variables']) 
			else:
				body += ' - '
		body += '\\\\\n'
	
	body += '\\hline\n\\textbf{Totals}'
	for algo in algos:
		if algo == 'M2': continue
		body += ' & ' + str(totals[algo]['racy_variables'])
	body += '\\\\'

	s = table_header + body + table_footer
	stream_latex(s, 'table2')


all = False
if len(sys.argv) > 1: all = sys.argv[2] == 'all'
print_table()
