from util import *

table_header = '''
\\setcounter{table}{2}
\\begin{table}
\\caption{
Numbers of different memory locations that are detected as racy.
}
\\label{tab:memloc}
\\setlength\\tabcolsep{1.5pt}
\\renewcommand{\\arraystretch}{1.2}
\\footnotesize
\\begin{tabular}{|c||c|c|c|}
\\hline
\\textbf{Benchmark} & \\textsf{SHB} & \\textsf{WCP} & $\\ZeroRevAlgo$ \\\\
\\hline\
'''

table_footer = '''
\\hline
\\end{tabular}
\\end{table}
'''


selected_benches = [
  'tsp',
  'batik',
  'cryptorsa',
  'jigsaw',
  'sunflow',
  'xalan',
  'ftpserver',
  'linkedlist',
  'luindex',
  'mergesort',
  'clean',
  'readerswriters',
  'wronglock'
]

def print_table():
	

	results = parse_dir()
	body = ''
	for b in results:

		if not all and b not in selected_benches: continue

		body += '\n\\texttt{' + short_name(b) + '}' 
		for algo in algos:
			if algo == 'M2': continue
			body += ' & '
			if 'max_distance' in results[b][algo]:
				body += events_pretty_print(results[b][algo]['max_distance']) 
			else:
				body += ' - '
		body += '\\\\'

	s = table_header + body + table_footer
	stream_latex(s, 'table3')


all = False
if len(sys.argv) > 1: all = sys.argv[2] == 'all'
print_table()
